//+------------------------------------------------------------------+
//|                                      MTF_FATL(RFTL).mq4          |
//|                                      Copyright  2006, Keris2112 |
//|Reference Fast Trend Line (RFTL)mtf   www.forex-tsd.com       ki  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Blue

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
**************************************************************************/
extern int TimeFrame = 0;
extern   int      MA_Period               = 34;
extern   int      MA_Type                 = 0;
extern   int      MA_Mode                 = 0;
extern   int      MA_AppliedPrice         = PRICE_CLOSE;
extern   int   ma_shift                  =0;
extern   int   ma_x_shift                =0;
extern   double   T3b                    = 0.618;
extern   double   JMA_Phase                = 0;
extern   int      MaxBarsToCount           = 900;
extern string  TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string  note__MA_Type_Mode ="SMA0 EMA1 SMMA2 LWMA3 DEMA4 TEMA5 T3MA6 JMA7 SATL8 FATL9";
extern string  MA_Price_ ="0C 1O 2H3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
 string short_name;

//---- indicator line
    IndicatorBuffers(3);

   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
 //   SetIndexEmptyValue(0,EMPTY_VALUE);
 //   SetIndexEmptyValue(1,EMPTY_VALUE);
 //   SetIndexEmptyValue(2,EMPTY_VALUE);

   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
 
   switch(MA_Type)
     {
      case 1 : short_name= " EMA(" ; break;
      case 2 : short_name= " SMMA("; break;
      case 3 : short_name= " LWMA("; break;
      case 4 : short_name= " DEMA("; break;
      case 5 : short_name= " TEMA("; break;
      case 6 : short_name= " T3MA("; break;
      case 7 : short_name= " JMA(" ; break;
      case 8 : short_name= " SATL("; break;
      case 9 : short_name= " FATL("; break;
      default: short_name= " SMA(" ;
     }

 
//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr= "M1";  break;
      case 5 : TimeFrameStr=        "M5";  break;
      case 15 : TimeFrameStr=       "M15"; break;
      case 30 : TimeFrameStr=       "M30"; break;
      case 60 : TimeFrameStr=       "H1";  break;
      case 240 : TimeFrameStr=      "H4";  break;
      case 1440 : TimeFrameStr=     "D1";  break;
      case 10080 : TimeFrameStr=    "W1";  break;
      case 43200 : TimeFrameStr=    "MN1"; break;
      default : TimeFrameStr=    "CurrTF";
   }

   SetIndexLabel(0,"xpMA "+short_name +" ("+ MA_Period+") ["+TimeFrameStr+"]");
   IndicatorShortName( "xpMA "+short_name +" ("+ MA_Period+") ["+TimeFrameStr+"]");

     if(TimeFrame==0) TimeFrame = Period();
 
   SetIndexShift(0,ma_shift+ ma_x_shift*TimeFrame/Period());
   SetIndexShift(1,ma_shift+ ma_x_shift*TimeFrame/Period());
   SetIndexShift(2,ma_shift+ ma_x_shift*TimeFrame/Period());
   SetIndexShift(3,ma_shift+ ma_x_shift*TimeFrame/Period());
   SetIndexShift(4,ma_shift+ ma_x_shift*TimeFrame/Period());
   SetIndexShift(5,ma_shift+ ma_x_shift*TimeFrame/Period());
   SetIndexShift(6,ma_shift+ ma_x_shift*TimeFrame/Period());


  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF                                                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
//limit= Bars-counted_bars+TimeFrame/Period();
limit= Bars-counted_bars;
limit= MathMax(limit,TimeFrame/Period());
limit= MathMin(limit,MaxBarsToCount);

   for(i=0,y=0;i<limit;i++)
   {
   if (TimeFrame<Period()) TimeFrame=Period();
   if (Time[i]<TimeArray[y]) y++;
/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"xpMA_v2_SATL_FATL_T3",MA_Period,MA_Type,MA_Mode,MA_AppliedPrice,T3b,JMA_Phase,MaxBarsToCount,0,y) ; 
 ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"xpMA_v2_SATL_FATL_T3",MA_Period,MA_Type,MA_Mode,MA_AppliedPrice,T3b,JMA_Phase,MaxBarsToCount,1,y) ; 
 ExtMapBuffer3[i]=iCustom(NULL,TimeFrame,"xpMA_v2_SATL_FATL_T3",MA_Period,MA_Type,MA_Mode,MA_AppliedPrice,T3b,JMA_Phase,MaxBarsToCount,2,y) ; 

    }

 //++++++++++++++++++++++++++++++++++++++++++++++++++++++  
   if (TimeFrame>Period()) {
     int PerINT=TimeFrame/Period()+1;
     datetime TimeArr[]; ArrayResize(TimeArr,PerINT);
     ArrayCopySeries(TimeArr,MODE_TIME,Symbol(),Period()); 
     for(i=0;i<PerINT+1;i++) {if (TimeArr[i]>=TimeArray[0]) {
 /********************************************************     
    Refresh buffers:         buffer[i] = buffer[0];
 ********************************************************/  
   ExtMapBuffer1[i]=ExtMapBuffer1[0];
   ExtMapBuffer2[i]=ExtMapBuffer2[0];
   ExtMapBuffer3[i]=ExtMapBuffer3[0];

   } } }
//+++++++++++++++++++++++++++++++++++++++++++++   Raff 
   return(0);
  }
//+------------------------------------------------------------------+