//+------------------------------------------------------------------+
//|                                           Weekly PowerLevels.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property copyright "Copyright  2007"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1 DodgerBlue
#property indicator_color2 Silver
#property indicator_color3 Magenta
#property indicator_style1 4
#property indicator_style2 4
#property indicator_style3 4
//---- input parameters
extern bool LineTEXT =true;
extern int  ShiftTEXT =0;
//---- buffers


double CurrWeekOpenBuffer[];
double PrevWeekHiBuffer[];
double PrevWeekLoBuffer[];

int fontsize=9;
double CurrWeekOpen, PrevWeekHi, PrevWeekLo;
double LastHigh,LastLow,x;


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

  
   
   ObjectDelete("CurrWeekOpen");   
   ObjectDelete("PrevWeekHi");
   ObjectDelete("PrevWeekLo");  
//
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
  
   
   SetIndexBuffer(0, PrevWeekHiBuffer);
   SetIndexBuffer(1, PrevWeekLoBuffer);
   SetIndexBuffer(2, CurrWeekOpenBuffer);
  
//---- name for DataWindow and indicator subwindow label
   short_name="Prev Weekly Hi-Lo levels";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int    counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)
{
   x=Period();
   //if (x>240) return(-1);
   if (LineTEXT == true)
	{
   ObjectCreate("PrevWeekHi", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("PrevWeekHi", "                             PrevWeekHi",fontsize,"Vendra", indicator_color1);
   ObjectCreate("PrevWeekLo", OBJ_TEXT, 0, 0, 0);   
   ObjectSetText("PrevWeekLo", "                              PrevWeekLo",fontsize,"Vendra", indicator_color2); 
   ObjectCreate("CurrWeekOpen", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("CurrWeekOpen", "                                    CurrWeekOpen",fontsize,"Vendra", indicator_color3);
   }
   //---- last counted bar will be recounted
//   if(counted_bars>0) counted_bars--;
} 
  limit=(Bars-counted_bars)-1;



for (i=limit; i>=0;i--)
{ 

if (High[i+1]>LastHigh) LastHigh=High[i+1];
if (Low[i+1]<LastLow) LastLow=Low[i+1];
//Print("TimeDay(Time[i]=",TimeDay(Time[i]),"TimeDay(Time[i+1])",TimeDay(Time[i+1]));
if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
   { 
   PrevWeekHi=LastHigh;
   PrevWeekLo=LastLow;
   CurrWeekOpen=Open[i];
   LastLow=Open[i];
   LastHigh=Open[i];

  
   ObjectMove("PrevWeekHi", 0, Time[0+ShiftTEXT], PrevWeekHi);
   ObjectMove("PrevWeekLo", 0, Time[0+ShiftTEXT], PrevWeekLo);
   ObjectMove("CurrWeekOpen", 0, Time[0+ShiftTEXT], CurrWeekOpen);

   }
   
    PrevWeekHiBuffer[i]=PrevWeekHi;
    PrevWeekLoBuffer[i]=PrevWeekLo;
    CurrWeekOpenBuffer[i]=CurrWeekOpen;
}

//----
   return(0);
  }
//+------------------------------------------------------------------+