
//+------------------------------------------------------------------+ 
//|                          _TRO_PRICE_LEVELS                       | 
//|                                                                  | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 8 
#property indicator_color1 Blue
#property indicator_color2 Blue 
#property indicator_color3 Blue
#property indicator_color4 Blue 
#property indicator_color5 Orange
#property indicator_color6 Orange 
#property indicator_color7 Orange 
#property indicator_color8 Orange 

//---- input parameters 
extern   int      max_bars=300; 
//extern bool      bDrawFibs = true; 
//extern bool      bResetOnNewDay = true; 

extern bool      PlotHiLow = true ;


extern double    iLevel1=0.25; 
extern double    iLevel2=0.50; 
extern double    iLevel3=0.75; 
extern double    iLevel4=1.00; 


//---- buffers 
double oTop; 
double oBot; 

double fb1[]; 
double fb2[]; 
double fb3[]; 
double fb4[]; 
double fb5[]; 
double fb6[]; 
double fb7[]; 
double fb8[]; 

double     iTop, open,close ;
double     iBot; 

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---- indicators 
   SetIndexStyle(0,DRAW_ARROW); 
   SetIndexArrow(0,119); 
   SetIndexBuffer(0,fb1); 
   SetIndexEmptyValue(0,0.0); 
   SetIndexStyle(1,DRAW_ARROW); 
   SetIndexArrow(1,119); 
   SetIndexBuffer(1,fb2); 
   SetIndexEmptyValue(1,0.0); 
   SetIndexStyle(2,DRAW_ARROW); 
   SetIndexArrow(2,119); 
   SetIndexBuffer(2,fb3); 
   SetIndexEmptyValue(2,0.0); 
   SetIndexStyle(3,DRAW_ARROW); 
   SetIndexArrow(3,119); 
   SetIndexBuffer(3,fb4); 
   SetIndexEmptyValue(3,0.0); 
   SetIndexStyle(4,DRAW_ARROW); 
   SetIndexArrow(4,119); 
   SetIndexBuffer(4,fb5); 
   SetIndexEmptyValue(4,0.0); 
   SetIndexStyle(5,DRAW_ARROW); 
   SetIndexArrow(5,119); 
   SetIndexBuffer(5,fb6); 
   SetIndexEmptyValue(5,0.0); 
   SetIndexStyle(6,DRAW_ARROW); 
   SetIndexArrow(6,119); 
   SetIndexBuffer(6,fb7); 
   SetIndexEmptyValue(6,0.0); 
   SetIndexStyle(7,DRAW_ARROW); 
   SetIndexArrow(7,119); 
   SetIndexBuffer(7,fb8); 
   SetIndexEmptyValue(7,0.0); 
   
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
    
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
    if(counted_bars < 0) 
        return(-1); 
//---- 
   int limit=Bars-counted_bars; 
    

   double nHH, nLL; 
   double range; 

   int processBars=MathMin(limit, max_bars); 
   for(int i=0;i<=processBars;i++){ 
   
            open     = Open[i] ;
            close    = Close[i] ;
            
            oTop     = High[ i+1 ]; 
            oBot     = Low[ i+1 ]; 
         
            if ( PlotHiLow ) range  = oTop - oBot; 
            else range =  MathAbs(Open[i+1] - Close[i+1]) ;
            
            fb1[i] = open + range*iLevel1; 
            fb2[i] = open + range*iLevel2; 
            fb3[i] = open + range*iLevel3; 
            fb4[i] = open + range*iLevel4; 
            fb5[i] = open - range*iLevel4; 
            fb6[i] = open - range*iLevel3; 
            fb7[i] = open - range*iLevel2; 
            fb8[i] = open - range*iLevel1; 
   
   } //end for 


   return(0); 
  } 
//+------------------------------------------------------------------+ 

