//+------------------------------------------------------------------+ 
//|                _TRO_Psycho_Zone                                  | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 



#property indicator_chart_window
//---- input parameters

extern int win = 0;
extern int price.x.offset= 250;//250
extern int price.y.offset= -160;//-190

extern bool show.info=true;
extern bool show.alert=true;

extern int    myStyle       = STYLE_DOT;
extern color  myTargetColor = DarkGreen ;
extern color  myLongColor   = Blue ;
extern color  myOpenColor   = White ;
extern color  myShortColor  = Red ;
extern color  myHourColor   = DarkGray ;
extern color  myAlertColor  = Yellow ;

extern double myProfitTarget   = 3 ;
extern double myStopLoss       = 7 ;


extern string  PS_session_name = "";




double open_price;
double rates_h1[2][6];
string PS_OP, PS_BZ, PS_BZW, PS_SZ, PS_SZW, PS_LTGT, PS_STGT;

double xPrice ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators


  PS_OP   = "Open " + PS_session_name;
  PS_BZ   = "Buy zone " + PS_session_name;
  PS_BZW  = "Buy zone width " + PS_session_name;
  PS_SZ   = "Sell zone " + PS_session_name;
  PS_SZW  = "Sell zone width " + PS_session_name;
  PS_LTGT = "Long Target"   + PS_session_name;
  PS_STGT = "Short Target " + PS_session_name;
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete(PS_OP);
   ObjectDelete(PS_BZ);
   ObjectDelete(PS_BZW);
   
   ObjectDelete(PS_SZ);
   ObjectDelete(PS_SZW);
   ObjectDelete(PS_LTGT);
   ObjectDelete(PS_STGT);
         
   ObjectDelete(PS_session_name);

   ObjectDelete("PS_630");
   ObjectDelete("PS_629");
   ObjectDelete("PS_629B");
   ObjectDelete("PS_631");
   ObjectDelete("PS_632");
   ObjectDelete("PS_634");

   
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----


   if( TimeHour(Time[0]) != TimeHour(Time[1]) ) 
     { 
        // draw the vertical bars that marks the time span
   double level= (High[1] + Low[1] + Close[1]) / 3;
   SetTimeLine("HourStart", "Hour", 0, White, level+10*Point);
     }
   
   
if ( Point == 0.01 )  {xPrice = Close[0] - MathMod(Close[0],0.25) ; }
else { xPrice = Close[0] - ( MathMod(100*Close[0],0.25 )*0.01 ) ;  }  

double LgProfit = xPrice + Point*25;
double ShProfit = xPrice - Point*25;

double LgTarget =  xPrice + myProfitTarget*Point ;
double ShTarget =  xPrice - myProfitTarget*Point ;

    if (ObjectFind(PS_OP) != 0)
    
      {
      
      
          ObjectCreate(PS_session_name,OBJ_TEXT,0,CurTime(),open_price+4*Point);
          ObjectSetText(PS_session_name, PS_session_name+"                                                                                                                                                        ",
                                                                                  8, "Arial",myHourColor);
      //    ObjectSet(session_name, OBJPROP_YDISTANCE, 100);
          
          
          ObjectCreate(PS_OP, OBJ_HLINE, 0, CurTime(), xPrice );
          ObjectSet(PS_OP, OBJPROP_STYLE, myStyle);
          ObjectSet(PS_OP, OBJPROP_COLOR, myOpenColor );
  /*          
          ObjectCreate(PS_BZ, OBJ_HLINE, 0, CurTime(), LgTarget );
          ObjectSet(PS_BZ, OBJPROP_STYLE, myStyle);
          ObjectSet(PS_BZ, OBJPROP_COLOR, myLongColor );
           
          ObjectCreate(PS_BZW, OBJ_HLINE, 0, CurTime(), LgTop );
          ObjectSet(PS_BZW, OBJPROP_STYLE, myStyle);
          ObjectSet(PS_BZW, OBJPROP_COLOR, myLongColor );
           
        
        
          ObjectCreate(PS_SZ, OBJ_HLINE, 0, CurTime(), Shtop);
          ObjectSet(PS_SZ, OBJPROP_STYLE, myStyle);
          ObjectSet(PS_SZ, OBJPROP_COLOR, myShortColor );
           
          ObjectCreate(PS_SZW, OBJ_HLINE, 0, CurTime(), ShBot);
          ObjectSet(PS_SZW, OBJPROP_STYLE, myStyle);
          ObjectSet(PS_SZW, OBJPROP_COLOR, myShortColor );
          
 */          
          ObjectCreate(PS_LTGT, OBJ_HLINE, 0, CurTime(), LgTarget );
          ObjectSet(PS_LTGT, OBJPROP_STYLE, myStyle);
          ObjectSet(PS_LTGT, OBJPROP_COLOR, myTargetColor );   
          
          ObjectCreate(PS_STGT, OBJ_HLINE, 0, CurTime(), ShTarget );
          ObjectSet(PS_STGT, OBJPROP_STYLE, myStyle);
          ObjectSet(PS_STGT, OBJPROP_COLOR, myTargetColor );    
          

      }
      
      else
      {
         ObjectMove(PS_session_name,0,CurTime(),open_price+4*Point);
         ObjectMove(PS_OP, 0, CurTime(), open_price);
/*         
         ObjectMove(PS_BZ, 0, CurTime(), LgTarget);
         ObjectMove(PS_BZW, 0, CurTime(), LgTop);                
         ObjectMove(PS_SZ, 0, CurTime(), ShTop);       
         ObjectMove(PS_SZW, 0, CurTime(), ShBot);
         
 */ 
         ObjectMove(PS_LTGT, 0, CurTime(), LgTarget );
         ObjectMove(PS_STGT, 0, CurTime(), ShTarget );         
    
      }


string tAlert = "PSYCHO" ;
myAlertColor = Yellow ;

//+------------------------------------------------------------------+ 
if ( show.alert) {    



bool LgTrigger = false ;
bool ShTrigger = false ;

double close = Close[0] ;
double diff  = close - Open[0] ;

if ( close >= LgTarget ) { tAlert = "    SELL" ;  myAlertColor = Red ; } else 

if ( (close == xPrice ) && ( diff > 0 ) ) { LgTrigger = true ; tAlert = "    BUY" ;   myAlertColor = Lime ; } else 
if ( (LgTrigger == true ) && ( close <=  xPrice - myStopLoss*Point) ) 
   { tAlert = "SL SELL" ;   myAlertColor = Red ; } 


if ( close <= ShTarget  ) { tAlert = "   COVER" ;  myAlertColor = Lime ; } else 

if ( ( close == xPrice  ) && ( diff > 0 ) ) {ShTrigger = true ; tAlert = "SELL SHORT" ;   myAlertColor = Red ; } else 
if ( (ShTrigger == true ) && ( close >=  xPrice + myStopLoss*Point ) ) 
   { tAlert = "SL COVER" ;   myAlertColor = Lime ; } 

   
} // if show.alert   
   
//+------------------------------------------------------------------+ 
if (show.info) {    

if ( show.alert == false ) {  myAlertColor = Gray ; }

   ObjectCreate("PS_630", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("PS_630", tAlert , 30, "Arial Bold", myAlertColor );
   ObjectSet("PS_630", OBJPROP_CORNER, 0);
   ObjectSet("PS_630", OBJPROP_XDISTANCE, 725+price.x.offset); // 760
   ObjectSet("PS_630", OBJPROP_YDISTANCE, 160+price.y.offset);
/* 
   ObjectCreate("PS_629", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("PS_629",DoubleToStr(LgTop,Digits), 15, "Arial Bold", Blue);
   ObjectSet("PS_629", OBJPROP_CORNER, 0);
   ObjectSet("PS_629", OBJPROP_XDISTANCE, 770+price.x.offset);
   ObjectSet("PS_629", OBJPROP_YDISTANCE, 197+price.y.offset);
   
   ObjectCreate("PS_629b", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("PS_629b",DoubleToStr( ShBot ,Digits), 15, "Arial Bold", Red);
   ObjectSet("PS_69b", OBJPROP_CORNER, 0);
   ObjectSet("PS_629b", OBJPROP_XDISTANCE, 770+price.x.offset);
   ObjectSet("PS_629b", OBJPROP_YDISTANCE, 260+price.y.offset);                 
*/                    
   ObjectCreate("PS_631", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("PS_631",DoubleToStr( xPrice ,Digits), 30, "Arial Bold", White );
   ObjectSet("PS_631", OBJPROP_CORNER, 0);
   ObjectSet("PS_631", OBJPROP_XDISTANCE, 765+price.x.offset); // 765
   ObjectSet("PS_631", OBJPROP_YDISTANCE, 215+price.y.offset); // 210
           
/* 
   ObjectCreate("PS_632", OBJ_LABEL, win, 0, 0);
   ObjectSetText("PS_632",DoubleToStr( LgProfit ,0), 15, "Arial Bold", LimeGreen);
   ObjectSet("PS_632", OBJPROP_CORNER, 0);
   ObjectSet("PS_632", OBJPROP_XDISTANCE, 860+price.x.offset);
   ObjectSet("PS_632", OBJPROP_YDISTANCE, 197+price.y.offset);
                 
   ObjectCreate("PS_634", OBJ_LABEL, win, 0, 0);
   ObjectSetText("PS_634",DoubleToStr( ShProfit ,0), 15, "Arial Bold", Crimson);
   ObjectSet("PS_634", OBJPROP_CORNER, 0);
   ObjectSet("PS_634", OBJPROP_XDISTANCE, 860+price.x.offset);
   ObjectSet("PS_634", OBJPROP_YDISTANCE, 260+price.y.offset);    
*/ 

//+------------------------------------------------------------------+  
   WindowRedraw();    
} // if showinfo
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Helper                                                           |
//+------------------------------------------------------------------+
void SetTimeLine(string objname, string text, int idx, color col1, double vleveltext) 
{
   string name= "[PIVOT] " + objname;
   int x= Time[idx];

   if (ObjectFind(name) != 0) 
      ObjectCreate(name, OBJ_TREND, 0, x, 0, x, 100);
   else {
      ObjectMove(name, 0, x, 0);
      ObjectMove(name, 1, x, 100);
   }
   
   ObjectSet(name, OBJPROP_STYLE, myStyle);
   ObjectSet(name, OBJPROP_COLOR, myHourColor);
   
   if (ObjectFind(name + " Label") != 0) 
      ObjectCreate(name + " Label", OBJ_TEXT, 0, x, vleveltext);
   else
      ObjectMove(name + " Label", 0, x, vleveltext);
            
   ObjectSetText(name + " Label", text, 8, "Arial", col1);
}