//+------------------------------------------------------------------+
//|       _TRO_xMeter                                                |
//|                             |
//|                                    |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
//----
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Green  // USD
#property indicator_color2 Blue   // EUR
#property indicator_color3 Red    // GBP
#property indicator_color4 Brown  // CHF
#property indicator_color5 White  // CAD
#property indicator_color6 Orange // AUD
#property indicator_color7 Yellow // JPY
 

  extern string note1 = "Display the price in what corner?";
  extern string note2 = "Upper left=0; Upper right=1";
  extern string note3 = "Lower left=2; Lower right=3";
  extern int    WhatCorner=0;


//---- buffers
double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];
double P5Buffer[];
double P6Buffer[];
double P7Buffer[];

#define ARRSIZE  12                     // number of pairs !!!DON'T CHANGE THIS NUMBER!!!
#define PAIRSIZE 7                      // number of currencies !!!DON'T CHANGE THIS NUMBER!!!
#define TABSIZE  10                     // scale of currency's power !!!DON'T CHANGE THIS NUMBER!!!

string aPair[ARRSIZE]   = {"EURUSD","GBPUSD","AUDUSD","USDJPY","USDCHF","USDCAD",
                           "EURJPY","EURGBP","EURCHF","EURAUD","GBPJPY","GBPCHF"};

//----
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  //----
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, P4Buffer);
   SetIndexBuffer(4, P5Buffer);
   SetIndexBuffer(5, P6Buffer);
   SetIndexBuffer(6, P7Buffer);

//----
  SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
  SetIndexLabel(0, "USD");
  SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
  SetIndexLabel(1, "EUR");
  SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 2);
  SetIndexLabel(2, "GBP");
  SetIndexStyle(3, DRAW_LINE, STYLE_SOLID, 2);
  SetIndexLabel(3, "CHF");
  SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, 2);
  SetIndexLabel(4, "CAD");
  SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, 2);
  SetIndexLabel(5, "AUD");
  SetIndexStyle(6, DRAW_LINE, STYLE_SOLID, 2);
  SetIndexLabel(6, "JPY");
//----
   IndicatorDigits(0);
   

   Comment("TRO");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("DBuyers");
   ObjectDelete("DSellers");
  
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   string aMajor[PAIRSIZE] = {"USD","EUR","GBP","CHF","CAD","AUD","JPY"};
   double aMeter[PAIRSIZE];
   double aHigh[ARRSIZE];
   double aLow[ARRSIZE];
   double aBid[ARRSIZE];
   double aAsk[ARRSIZE];
   double aRatio[ARRSIZE];
   double aRange[ARRSIZE];
   double aLookup[ARRSIZE];
   double aStrength[ARRSIZE];
   double point;
   int    index;

   int i,ii;
   static int pii=-1;
   
   for(i = 0; i <iBars(Symbol(),PERIOD_M1) ; i++)
     {
       ii = iBarShift(Symbol(), Period(), iTime(Symbol(),PERIOD_M1,i), true);
       //----
       if (pii!=ii)
       {
         P1Buffer[ii]=0;
         P2Buffer[ii]=0;
         P3Buffer[ii]=0;
         P4Buffer[ii]=0;
         P5Buffer[ii]=0;
         P6Buffer[ii]=0;
         P7Buffer[ii]=0;
       }
       
       if (ii != -1)
       {      
   for (index = 0; index < ARRSIZE; index++)                                // initialize all pairs required value 
      {
      RefreshRates();                                                       // refresh all currency's instrument
      point            = getPoint(aPair[index]);                            // get a point basis
      aHigh[index]     = MarketInfo(aPair[index],MODE_HIGH);                // set a high today
      aLow[index]      = MarketInfo(aPair[index],MODE_LOW);                 // set a low today
      aBid[index]      = MarketInfo(aPair[index],MODE_BID);                 // set a last bid
      aAsk[index]      = MarketInfo(aPair[index],MODE_ASK);                 // set a last ask
      aRange[index]    = MathMax((aHigh[index]-aLow[index])/point,1);       // calculate range today
      aRatio[index]    = (aBid[index]-aLow[index])/aRange[index]/point;     // calculate pair ratio
      aLookup[index]   = iLookup(aRatio[index]*100);                        // set a pair grade
      aStrength[index] = 9-aLookup[index];                                  // set a pair strengh
      } 
       }
   P1Buffer[i] = NormalizeDouble((aLookup[3]+aLookup[4]+aLookup[5]+aStrength[0]+aStrength[1]+aStrength[2])/6,2);
   P2Buffer[i] = NormalizeDouble((aLookup[0]+aLookup[6]+aLookup[7]+aLookup[8]+aLookup[9])/5,2);
   P3Buffer[i] = NormalizeDouble((aLookup[1]+aLookup[10]+aLookup[11]+aStrength[7])/4,2);
   P4Buffer[i] = NormalizeDouble((aStrength[4]+aStrength[8]+aStrength[11])/3,2);
   P5Buffer[i] = NormalizeDouble((aStrength[5]),2);
   P6Buffer[i] = NormalizeDouble((aLookup[2]+aStrength[9])/2,2);
   P7Buffer[i] = NormalizeDouble((aStrength[3]+aStrength[6]+aStrength[10])/3,2);  

       pii=ii;
    }
    
//    SetLabel("DBuyers","Buyers="+DoubleToStr(P1,0),1,30,"Simplified Arabic Fixed",20,0,Lime);
//    SetLabel("DSellers","Sellers="+DoubleToStr(P2,0),1,92,"Simplified Arabic Fixed",20,0,Red);
     
  
    
//----
   return(0);
  }

//+------------------------------------------------------------------+
                                                                           
//----

  
int iLookup(double ratio)                                                   // this function will return a grade value
  {                                                                         // based on its power.
   int    aTable[TABSIZE]  = {0,3,10,25,40,50,60,75,90,97};                 // grade table for currency's power
   int    index;
   
        if (ratio < aTable[1])  index = 0;
   else if (ratio < aTable[2])  index = 1;
   else if (ratio < aTable[3])  index = 2;
   else if (ratio < aTable[4])  index = 3;
   else if (ratio < aTable[5])  index = 4;
   else if (ratio < aTable[6])  index = 5;
   else if (ratio < aTable[7])  index = 6;
   else if (ratio < aTable[8])  index = 7;
   else if (ratio < aTable[9])  index = 8;
   else                         index = 9;
   return(index);                                                           // end of iLookup function
  }
  
double getPoint(string pair)
  {
   double point;
   
   point = 0.01;
   if (StringFind(pair,"JPY") == EMPTY) point = 0.0001;
   return(point);
  }


//+------------------------------------------------------------------+