#property copyright "_mikkom"
#property link      "http://www.kirkas.com"

//#property indicator_separate_window
#property indicator_chart_window

extern int backbars = 1000;
extern int dividex = 50;
extern int backscreens = 2;

string name = "resistanceObject_";

int init() {

   IndicatorBuffers(2);
   
   IndicatorShortName("Mikko resistance "+backbars);
   clear();
   return(0);
}
  
int deinit() {
   clear();
   return(0);
}

     
int start() {
       
   int counted_bars=IndicatorCounted();
  
   if(counted_bars < 0)
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;

   double y, y2;
   datetime x, x2;
       
   int limit = Bars - counted_bars;
   int xbegin = limit;
   
   if(xbegin > WindowBarsPerChart() * backscreens)
      xbegin = WindowBarsPerChart() * backscreens;

   double min = Low[iLowest(Symbol(),0,MODE_LOW,xbegin)];
   double max = High[iHighest(Symbol(),0,MODE_HIGH,xbegin)];
   
   int xscale = WindowBarsPerChart()/dividex;   
   double yscale = 5 * Point;
   
   int counter = 0;
   int xpos;
   double totalvolume;
   
   if(backbars < 0) {
      backbars = WindowBarsPerChart();
   }
         
   int heatMax = 0;

   for(xpos=xbegin; xpos>0; xpos -= xscale) {
      
      x = Time[xpos];

      if(xpos - xscale < 0) 
         x2 = Time[0];
      else
         x2 = Time[xpos - xscale];                              

      double llow = Low[iLowest(Symbol(),0,MODE_LOW,backbars,xpos)];
      double hhigh = High[iHighest(Symbol(),0,MODE_HIGH,backbars,xpos)];
      
      for(y=MathRound(llow/yscale)*yscale; y<=hhigh; y+=yscale) {
         y2 = y+yscale;

         double tops, total;
         
         tops = 0;
         total = backbars;

         for(int i=0; i<backbars; i++) {
             if(High[xpos+i] > y && High[xpos+i] < y2) {
                tops++;
             }
             if(Low[xpos+i] > y && Low[xpos+i] < y2) {
                tops++;
             }
         }
         if(tops > 0) {
         int heat = MathRound(tops/total*255 * 20);    
         if(heat > 255)
            heat = 255;
                                                
         int c = heat + heat << 8 + heat << 8 << 8;

         int win = 0;
         string id = name+(counter);
         ObjectCreate(id, OBJ_RECTANGLE, win, x, y, x2, y2);    
         ObjectSet(id, OBJPROP_COLOR, c);
                
         counter++;
         }         
         }
      
      
      
   }  
   
   // multiply color
   /*
   for(i=0; i<counter; i++) {
       id = name+i;   
       ObjectSet(id, OBJPROP_COLOR, (ObjectGet(id, OBJPROP_COLOR) / heatMax)*255);
   }
   */

   return(0);
}


void clear() {
   for(int i = 0; i <= 100000; i++) {
      if(!ObjectDelete(name+i))
         return;
   }
}

